from weavel import create_client, WeavelClient, Trace
from uuid import uuid4
import time


client: WeavelClient = create_client()

user_identifier = "USER IDENTIFIER EXAMPLE"

data = [{'id': 11585, 'type': 'assistant_message', 'uuid': 'de59e438-784a-4e5a-a98c-81c43b88a1cc', 'resume': False, 'content': 'Hello, nice to meet you again. And, uh, and what seems to be the-the problem or what-what prompted you to come along?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:00:27+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11602, 'type': 'user_message', 'uuid': '9b9bfcdb-412b-4132-bd56-886045aeb418', 'resume': False, 'content': "Uh, just I'm sick of my drinking. I'm drinking too much. Um, I just thought, uh, maybe I need someone to talk to, get some help about it.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:00:35+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11666, 'type': 'assistant_message', 'uuid': '80f61acd-a78e-4c49-b86c-68ca5150ffd2', 'resume': False, 'content': 'Okay, so you feel as if drinking is a problem for you at the moment?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:00:46+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11680, 'type': 'user_message', 'uuid': '13a19adb-e27d-44b4-821b-423af75650ce', 'resume': False, 'content': "Yeah, it's just- it's just got worse over the last six months?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:00:52+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11742, 'type': 'assistant_message', 'uuid': '820ce556-2781-419d-8773-d1957377f656', 'resume': False, 'content': "Okay. Wh-What makes you say that it's gotten worse?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:00:57+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11759, 'type': 'user_message', 'uuid': 'c215a26d-f1fd-44e4-896e-c407eec3b089', 'resume': False, 'content': 'Well, I guess, I drank, you know, like most people do before, um, but I broke up with my boyfriend, uh, about a year ago and then six months ago I guess I wanted to go out again and see if I can meet people.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:02+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11799, 'type': 'assistant_message', 'uuid': 'e938791d-cf93-43a3-b5e6-55a9e48ceb10', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:20+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11814, 'type': 'user_message', 'uuid': 'cb9da801-e1a2-4311-afad-0a011106757f', 'resume': False, 'content': "And I've been, yeah, getting into this habit of going out every Friday and Saturday, now, uh, drinking a lot.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:21+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11860, 'type': 'user_message', 'uuid': 'bcf47d01-40cb-46b2-913d-b04fdf4b08b9', 'resume': False, 'content': 'Um, to try to meet guys.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:30+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11848, 'type': 'assistant_message', 'uuid': '36c13061-939b-4eb1-82ee-b6269a000803', 'resume': False, 'content': 'Yes.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:30+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11893, 'type': 'user_message', 'uuid': '8dab5cd0-60c4-4bf0-a134-bfc0c2b356a2', 'resume': False, 'content': "And, uh, in the last few months I've been, you know, just drinking even more on week nights, and I never even used to do that before.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11881, 'type': 'assistant_message', 'uuid': '2ba23b9a-7212-4c63-9407-0474c8465697', 'resume': False, 'content': 'Sure.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11913, 'type': 'assistant_message', 'uuid': 'fc795ac0-9284-4f53-abd4-28c9447a199f', 'resume': False, 'content': "Okay, okay, so you've noticed over, I guess, uh, the last six months in particular since you decided, you know what? I'm going to take a risk and-a-and go out to try to meet a-a-a pot-potential partner again that it's with an increase in drinking.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:01:44+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11923, 'type': 'user_message', 'uuid': 'f47e9ba9-754f-4364-ac69-4e1c408572fc', 'resume': False, 'content': "Yeah. Well, I just, I don't feel comfortable talking to guys normally. [chuckles]", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:02+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11956, 'type': 'user_message', 'uuid': '1265da00-3173-4bc8-9b64-ff2f02c098d8', 'resume': False, 'content': "I don't know what to say, um, and I just, drinking helps.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:10+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11950, 'type': 'assistant_message', 'uuid': 'ff5d7a08-1af4-4891-bb84-72d8d2a4a59f', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:10+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11989, 'type': 'assistant_message', 'uuid': 'e7af1759-b090-46b4-b44c-64fabc329c6f', 'resume': False, 'content': "Sure, sure. So you're noticing that the drinking at the moment is a way of perhaps calming the nerves?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:14+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12000, 'type': 'user_message', 'uuid': 'f2ad481d-8030-4ff9-bc83-c0d0e6eda7eb', 'resume': False, 'content': 'Yeah, for sure.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:20+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11588, 'type': 'assistant_message', 'uuid': '9365958c-a9de-4a60-a026-5865cc963fd8', 'resume': False, 'content': 'To-to-to speak to-to potential partners?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:21+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11607, 'type': 'user_message', 'uuid': '115c85ad-ae4e-41d6-b2a1-9aeccc32bf81', 'resume': False, 'content': 'Yeah, definitely.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:24+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11665, 'type': 'assistant_message', 'uuid': '059cdaa0-0947-4511-bcf4-aba14f7d9867', 'resume': False, 'content': 'Who-who-who, boys?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:25+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11679, 'type': 'user_message', 'uuid': '34a2561a-54c4-457f-bb73-ddf12961a097', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:25+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11720, 'type': 'assistant_message', 'uuid': '734dfb20-5ea5-4e87-b3dc-ad5240ba86ae', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:26+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11736, 'type': 'user_message', 'uuid': '22b9f83a-4c1a-439c-9400-9274b1ac2ca9', 'resume': False, 'content': 'I mean, I guess, like most people do when they go out they drink.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:27+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11792, 'type': 'assistant_message', 'uuid': '5abf4fa9-f108-4707-a2d6-6f3ab4876d2d', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:29+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11806, 'type': 'user_message', 'uuid': 'eb4d7537-638d-4a77-b25a-2366c25b74b3', 'resume': False, 'content': "I've been doing that and just drinking more and more I guess.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:30+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11839, 'type': 'assistant_message', 'uuid': 'cf534a98-6cc0-4c9d-88f6-0f32075372e0', 'resume': False, 'content': 'Sure.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11847, 'type': 'user_message', 'uuid': '29ec02a6-4840-439c-a682-fcfea28b8494', 'resume': False, 'content': "Um, and it's just-- it's not even working, I'm not really meeting people and I just end up with massive hangover for the rest of the weekend and—", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:35+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11874, 'type': 'assistant_message', 'uuid': 'd20302e6-fa5c-4b12-86f4-fff8df3827e6', 'resume': False, 'content': "That's interesting isn't it? You-- 'cause you kind of mentioned it there, like, you know, on one side of the coin, um, it helps calm the nerves to get yourself get out there and-", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:46+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11910, 'type': 'assistant_message', 'uuid': '07290b05-9124-4043-9a88-aa226c727d19', 'resume': False, 'content': "-talk to guys at the same time, on the other side it's not working you're finding. And i-i-it results in hangovers or?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:56+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11879, 'type': 'user_message', 'uuid': '3670180c-7a17-4b35-88a2-7cc9fa8aeb8f', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:02:56+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11920, 'type': 'user_message', 'uuid': '0fa81a44-5dff-460c-b44b-54e4d3acf7ec', 'resume': False, 'content': "Yeah, I mean, I've maybe talked to people but it's just, uh, that I've just I think I'm just too-too drunk and I just, my friends drive me home and just the end of the night I don't-- yeah.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:05+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11946, 'type': 'assistant_message', 'uuid': 'ccea2ebd-5a9d-4d18-9c26-1ce1b60bc530', 'resume': False, 'content': 'Okay, and so I guess, you know, what would you like to do given the circumstances?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:20+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11953, 'type': 'user_message', 'uuid': '14fe7ffd-c09c-45f3-b53c-94f59cd08f99', 'resume': False, 'content': "I guess I just wanna stop. I just feel like I'm drinking more and more 'cause I'm doing it now in the weekdays-", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:28+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11997, 'type': 'user_message', 'uuid': '0e25240e-733c-42f0-8ef4-da3ca13b1695', 'resume': False, 'content': "-and I mean, I just don't-- I don't wanna do that every now and now I just think it's a bit too much.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11985, 'type': 'assistant_message', 'uuid': '79848ac7-779c-43eb-a1d6-c8b6e3303e9a', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12032, 'type': 'assistant_message', 'uuid': 'c895c8d7-f90d-4231-af94-267b0660e1ca', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:42+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12042, 'type': 'user_message', 'uuid': 'cc5f2fb6-45a9-4171-bfce-f2313af413b1', 'resume': False, 'content': "Yeah, I'm just I'm not eating properly anymore, I'm just eating less or just getting takeaway, getting crap food and-", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:43+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11625, 'type': 'user_message', 'uuid': 'cc08699e-7748-40b5-a359-9800ebe4e0cf', 'resume': False, 'content': "-um, I'm just, I feel like I'm not exerc-- well I'm not exercising like I used to. So, I just wanna cut, you know, stop drinking so much.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:52+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11608, 'type': 'assistant_message', 'uuid': '1527df12-0cc7-4ad5-93ed-696a85b8d9cb', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:03:52+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11697, 'type': 'assistant_message', 'uuid': 'fabcd35d-fc32-487c-8d7a-c453e836d129', 'resume': False, 'content': 'Okay, okay, so, uh, sounds like you really want to stop drinking, particularly during the weekdays?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:04+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11712, 'type': 'user_message', 'uuid': 'a2ab1d70-3538-4b13-bce4-22358b7e1469', 'resume': False, 'content': 'Yeah. Yeah I do. Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:12+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11771, 'type': 'assistant_message', 'uuid': 'ded73b30-7925-47fc-9169-4f050b9f0b95', 'resume': False, 'content': "Right, because you're noticing it's having a negative impact on what you're eating.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:14+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11782, 'type': 'user_message', 'uuid': '3a2c6383-877a-4f85-825b-3c2f1a3abb41', 'resume': False, 'content': "Yeah. I don't wanna- I don't wanna, I mean, I don't wanna stop altogether, so.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:18+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11826, 'type': 'assistant_message', 'uuid': '07e36bc9-8631-40c7-950b-f6287cd39661', 'resume': False, 'content': "No, I get it. Yeah. I mean, you know, it sounds like it's, it is helpful to a degree for you when you go out because it makes you feel a little bit more calm to talk to-to guys is that right?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:23+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11832, 'type': 'user_message', 'uuid': '6582b6ed-b391-42b7-a355-fb26fd5ccda3', 'resume': False, 'content': 'Yeah and just and all my friends go out and drink. Like I-', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:33+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11863, 'type': 'assistant_message', 'uuid': '2d123441-f75a-4133-8f95-26abde9df309', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:37+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11871, 'type': 'user_message', 'uuid': 'c014ba63-dcb0-497d-81fa-d4861634940b', 'resume': False, 'content': "-I'd have no social life if I didn't.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:39+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11896, 'type': 'assistant_message', 'uuid': 'c359fc43-0124-48cb-94d0-740c2481a863', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:42+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11905, 'type': 'user_message', 'uuid': 'e2891dcc-5c8f-455b-90d8-2d9eaacc80c1', 'resume': False, 'content': 'If I just said-said, "No, I\'m not drinking at all," and, you know, I don\'t feel like I\'m an alcoholic-', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:43+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11943, 'type': 'user_message', 'uuid': 'f395c2b6-369b-482e-b3d3-7e2d12824acb', 'resume': False, 'content': "-or I don't feel like I need to", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:47+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11935, 'type': 'assistant_message', 'uuid': 'db67f526-bbce-4846-a2be-83e314a198f7', 'resume': False, 'content': 'Sure.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:47+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11967, 'type': 'assistant_message', 'uuid': 'c6c46ecc-b166-4cb5-afb4-3ea8e60f44d8', 'resume': False, 'content': 'Yeah, yeah. So, you\'ve got, you know, some benefits there then, you know. The social element, hanging with friends and-and going out together is something which is-is quite enjoyable. So, it\'s not a case of removing it completely but it’s a case of, "Okay, I’m noticing this is impacting on me more than what I’d like to." Yeah. Yeah, okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:04:49+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11975, 'type': 'user_message', 'uuid': 'd056a669-8271-4035-be2c-4c7dd7d72e11', 'resume': False, 'content': 'Yeah, it just got a bit out of control.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:07+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12016, 'type': 'assistant_message', 'uuid': 'dc511be4-08e6-4c96-8371-c25a1427da09', 'resume': False, 'content': 'Has there been times in the past where you’ve tried to cut back on drinking?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:09+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12027, 'type': 'user_message', 'uuid': '69d3afc2-2eaa-4689-a46d-6c618d9ed788', 'resume': False, 'content': 'No, this hasn’t happened before.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:15+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12057, 'type': 'assistant_message', 'uuid': '9f200f8c-3e51-4ae5-9837-8c6c7afd44cf', 'resume': False, 'content': 'Oh, this is the first time anything like this has come up?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:19+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12064, 'type': 'user_message', 'uuid': '4dd5fa29-412d-4b59-ab03-6e3d90c97833', 'resume': False, 'content': 'Um, due to just circumstance of, I mean, I just yeah, had my boyfriend for six years before that and-', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:24+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11630, 'type': 'assistant_message', 'uuid': '3c919bda-6620-4a91-8fa5-6c189eee2017', 'resume': False, 'content': 'Yes, yes.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:30+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11648, 'type': 'user_message', 'uuid': 'ef73a54d-a70b-49a8-8eaf-8a32e8a0aba2', 'resume': False, 'content': "Um, before that yeah just my friends weren't drinking so much, and yeah it’s just not, it's just new. Yeah.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:32+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11692, 'type': 'assistant_message', 'uuid': '1bdca230-ba89-49d3-9182-0a8326dad62b', 'resume': False, 'content': "Okay, yeah. Well, it’s great that you’re able to identify, you know, what’s going on at the moment and you've-- not only know that, you almost picked up on a bit of a pattern too you're in-", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:41+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11706, 'type': 'user_message', 'uuid': '8030e481-c06f-4d33-8756-e68727b9cf0b', 'resume': False, 'content': 'Mm-hmm.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:52+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11764, 'type': 'assistant_message', 'uuid': 'ba6b93eb-5528-4e66-8f6e-55d9e93796d3', 'resume': False, 'content': "-as to why you’re-you're drinking. In terms of looking at cutting back on-on drinking, you know, on a scale of 0 to 100 and 100, uh, meaning it’s tremendously important for you and 0 not important at all. How important is it for you to cut back on the drinking?", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:05:53+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11775, 'type': 'user_message', 'uuid': '82a78698-3a69-4baf-a66a-11bb96d4aa53', 'resume': False, 'content': 'I believe 80, I mean I guess that’s why I’m here so—', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:13+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11819, 'type': 'assistant_message', 'uuid': '07d724b9-d6f0-4eb7-a31f-dd038ab67022', 'resume': False, 'content': "Okay, yeah yeah sure, you're already taking a huge step forward in many ways by coming along to-to start talking about it.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:17+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11827, 'type': 'user_message', 'uuid': 'ef590e87-8239-4460-a2ae-49c0235df4ec', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:24+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11856, 'type': 'assistant_message', 'uuid': '24b90813-d121-41a2-be33-2259e8fa7247', 'resume': False, 'content': 'Um, I guess 80 is quite high, what makes you say an 80 over say 50?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:25+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11864, 'type': 'user_message', 'uuid': '5e9b8396-3ce3-47dc-8296-f866da6cdb65', 'resume': False, 'content': 'Um, I don’t know, I just-just I don’t know, it just sort-- it just got up to a point where just, um, it seemed just too much, like no-nobody else is really drinking as much in the week as well and-', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:31+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11891, 'type': 'assistant_message', 'uuid': 'f6cf2f6d-ada5-49cb-b4c4-2e34f0da75f3', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:47+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11897, 'type': 'user_message', 'uuid': 'ca0125d1-9109-4907-985c-e68ab8008f91', 'resume': False, 'content': '-it seemed, as just, yeah, for the reasons I was saying, just seeing like I need to do something about it now.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:48+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11924, 'type': 'assistant_message', 'uuid': '82b95f86-a41b-4d86-b3e2-49653ff91d3d', 'resume': False, 'content': 'Okay, yes, so you’ve got this real sense of, "I\'ve gotta do something."', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:06:55+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11931, 'type': 'user_message', 'uuid': 'ec1d7cfb-ae35-4240-80aa-6d2187ee0e2f', 'resume': False, 'content': 'Just seeing it’s just gonna get worse, uh, wha-- that’s what it seems like.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:00+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11954, 'type': 'assistant_message', 'uuid': '44ef9f15-f563-45d1-8658-efa6c5c1ab1a', 'resume': False, 'content': 'That’s what it seems like.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:03+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11961, 'type': 'user_message', 'uuid': '919f951f-8a9f-4b23-bafa-a0bb034e288b', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:04+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11995, 'type': 'assistant_message', 'uuid': '83680612-872a-4c2a-975c-760dafd797c7', 'resume': False, 'content': "So, at the moment, it's been a case of the last six months, this is a pattern that you’ve been noticing more and more, um, a sign that it has had negative impacts on your lifestyle which you’re not happy with and you are in you're in a position where, you know what? I wanna do something about it.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:05+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12002, 'type': 'user_message', 'uuid': '2c333da4-c1f4-4f55-9f26-7a955eeb0ed0', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:20+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12035, 'type': 'assistant_message', 'uuid': 'cf51f32e-5c7c-47f5-8732-ed4335ee864e', 'resume': False, 'content': 'Okay, I mean what do you think that next step is?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:21+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 12041, 'type': 'user_message', 'uuid': '4fc75ee1-90c9-4196-a0ef-bf3ce3c9a26e', 'resume': False, 'content': 'Um, I guess that’s why I’m here. [chuckles]', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:26+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11652, 'type': 'assistant_message', 'uuid': '35a50ae2-f178-4369-8e28-b6bb4c4a110d', 'resume': False, 'content': 'Yeah.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:27+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11664, 'type': 'user_message', 'uuid': 'b0732d87-a715-425c-a649-837012034e69', 'resume': False, 'content': 'Just to, uh, but um-- I is-is-- I think the weekdays is what I really need to do.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:28+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11721, 'type': 'assistant_message', 'uuid': '42d41030-2ac9-4d9c-a4b2-0e5bf3707778', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:33+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11740, 'type': 'user_message', 'uuid': 'cb548e2a-08a9-4fe2-9aec-aa1ece865a84', 'resume': False, 'content': 'Um, and then, I don’t know, try to plan it out a little bit more on the weekends-', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:34+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11787, 'type': 'assistant_message', 'uuid': '316f8159-c396-439f-b4a7-3bb83e3d13e9', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:42+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11803, 'type': 'assistant_message', 'uuid': 'fc37cfce-aeae-4694-944d-49b40ccdf6d9', 'resume': False, 'content': '-so it just doesn’t go crazy.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:43+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11816, 'type': 'assistant_message', 'uuid': '999372b8-c23f-4dfe-a701-3e2bbfeeebf9', 'resume': False, 'content': 'Okay, okay, so you’re thinking about perhaps looking at trying to keep weekdays free of alcohol? Was that what you were saying?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:48+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11825, 'type': 'user_message', 'uuid': 'b299a59b-a779-4b70-a33e-02507eb55621', 'resume': False, 'content': 'Yeah, yeah. Yep.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:07:58+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11858, 'type': 'assistant_message', 'uuid': 'd7f9b227-fce3-4f46-89da-cd6833a53a1c', 'resume': False, 'content': 'Okay, how does that sound like a first step goal for you?', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:01+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11865, 'type': 'user_message', 'uuid': '9a93708d-debf-44ea-8000-8971782111dd', 'resume': False, 'content': "No, that’s good, that’s-that's, yeah, that's- that is definitely what I’m gonna do.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:07+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11892, 'type': 'assistant_message', 'uuid': 'a2cbe63f-042f-47a4-95a4-67fc6c4016e9', 'resume': False, 'content': 'Okay.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:11+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11901, 'type': 'user_message', 'uuid': '0ae67233-c4c3-4367-868c-968d73894eb5', 'resume': False, 'content': "I just, you know, I'm so out of the routine, not exercising, I need to get back into things.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:12+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11929, 'type': 'assistant_message', 'uuid': '63292d54-1d9e-4261-88b6-142d4d42004f', 'resume': False, 'content': 'Okay, you sound really mad about it to-to turn it around.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:16+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11939, 'type': 'user_message', 'uuid': '5c4bdc08-9470-42e8-ab2b-32d726f72982', 'resume': False, 'content': 'Yeah, but I mean, I guess, just talking about it makes me think oh yeah, I need to- I need to do something about it.', 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:22+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}, {'id': 11963, 'type': 'assistant_message', 'uuid': '1058c05c-d1a2-461a-9899-42c222a55ca2', 'resume': False, 'content': "Okay, oh, that-that's excellent, okay.", 'metadata': None, 'embedding': None, 'unit_uuid': None, 'user_uuid': '7d5885a4-03f7-457e-8386-a5c1f384ed98', 'created_at': '2024-02-02T00:08:27+00:00', 'trace_uuid': '137a425e-10f0-4e7a-aabe-96594a559cc1', 'project_uuid': '3b94ee33-de25-4503-981a-468964de81be'}]

trace: Trace = client.open_trace(user_identifier, trace_id=str(uuid4())) # -> trace_id

res = "I can assist you with a variety of tasks. I can help answer questions, provide information, give suggestions, assist with research, set reminders, manage your schedule, make reservations, provide translations, and much more. Just let me know what you need help with!"

# print(res.choices[0].message.content)

for td in data[:12]:
    if td["type"] == "assistant_message":
        trace.log_message("assistant", td["content"])
    else:
        trace.log_message("user", td["content"])
    time.sleep(0.5)
        
# res = openai_client.chat.completions.create(
#     model="gpt-3.5-turbo",
#     messages=[
#         {"role": "system", "content": "You are a helpful assistant"},
#         {"role": "user", "content": user_message}
#     ]
# )


# second_trace: Trace = client.open_trace(user_id)
# second_trace.log_message("user", "hello!", unit_name="second_testapp")
# second_trace.log_message("assistant", "I can help you with a variety of tasks.", unit_name="second_testapp")
# second_trace.log_message("system", "you are a helpful assistant.")

client.close()